security:
  encoders:
    FOS\UserBundle\Model\UserInterface: pbkdf2
  providers:
    chain_provider:
      chain:
        providers: [fos_provider, ldap_provider]
    ldap_provider:
      ldap:
        service: Symfony\Component\Ldap\Ldap
        base_dn: "%ldap_base_dn%"
        search_dn: "%ldap_search_dn%"
        search_password: "%ldap_search_password%"
        default_roles: ROLE_USER
        uid_key: sAMAccountName
        filter: (&(objectclass=user)(objectCategory=person)({uid_key}={username}))
    fos_provider:
      id: fos_user.user_provider.username
  role_hierarchy:
    ROLE_ADMIN: ROLE_USER
    ROLE_SUPER_ADMIN: ROLE_ADMIN
  firewalls:
    dev:
      pattern: ^/(_(profiler|wdt)|css|images|js)/
      security: false
    main:
      pattern: ^/
      form_login:
        provider: fos_provider
        check_path: fos_user_security_check
        login_path: /
        csrf_token_generator: security.csrf.token_manager
        use_referer: false
        success_handler: kaiframework.loginsuccess.handler.service
        failure_handler: kaiframework.loginfailure.handler.service
      logout:
        path: /logout
        handlers: [kaiframework.logout.handler.service]
        success_handler: kaiframework.logoutsuccess.handler.service
      anonymous: true
      #form_login_ldap:
      #    provider:  chain_provider
      #    login_path: /
      #    check_path: fos_user_security_check
      #    service: Symfony\Component\Ldap\Ldap
      #    dn_string: '{username}'
      #    use_referer: false
      #    success_handler: kaiframework.loginsuccess.handler.service
      #    failure_handler: kaiframework.loginfailure.handler.service
      # activate different ways to authenticate

      # http_basic: true
      # https://symfony.com/doc/current/security.html#a-configuring-how-your-users-will-authenticate

      # form_login: true
      # https://symfony.com/doc/current/security/form_login_setup.html

  # Easy way to control access for large sections of your site
  # Note: Only the *first* access control that matches will be used
  access_control:
    - { path: ^/(tr|en)/m2m, roles: IS_AUTHENTICATED_ANONYMOUSLY, ips: [127.0.0.1, 192.168.1.10, 192.168.1.40, 192.168.1.98, 172.16.1.149, 10.10.0.10, 10.0.0.101, 192.168.10.6, "::1"]}
    - { path: ^/(tr|en)/m2m, roles: ROLE_NO_ACCESS }
    - { path: ^/api, roles: IS_AUTHENTICATED_FULLY }
    - { path: ^/, role: IS_AUTHENTICATED_ANONYMOUSLY }